#include <iostream>
#include <vector>
using namespace std;
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n,c,q,L,R,broj1;
    string s;
    cin>>n>>c>>q>>s;
    vector<bool> a(n);
    for(int i=0;i<n;i++){
        a[i]=int(s[i])-48;
        broj1+=(s[i]==1 ? 1: 0);      
    }
    if(n==c){
        for(int z=0;z<q;z++){
            cin>>L>>R;
            for(int i=L-1;i<R;i++){
                a[i]=!a[i];
                broj1+=(a[i]==1 ? 1 : -1);
            }
            cout<<broj1<<"\n";
        }
    }
}